/*
 * uart.h
 *
 *  Created on: 2011/07/31
 *      Author: lynxeyed
 */

#ifndef UART_H_
#define UART_H_

#include "LPC11xx.h"
#ifdef __cplusplus
  extern "C" {
#endif

typedef enum {marySerial1,mbedSerial1,mbedSerial2} SERIAL_PORT; // Defaults:marySerial1
typedef enum {BYTE, BIN, OCT, DEC, HEX} SERIAL_FORMAT;



class USerial {
private:
	SERIAL_PORT port;
	SERIAL_FORMAT format;
	int speed;

public:
	USerial();//USerial(SERIAL_PORT port);		// announce the constructor to initialize
	~USerial();

	void begin(int speed);
	void end() ;
	void print(const char *s);
	void print(int val, SERIAL_FORMAT format);
	void println(const char *s);
	void println(int val, SERIAL_FORMAT format) ;
	int  read(void);
	void write(const char c);
	void write(const char *s,int length);
};


#ifdef __cplusplus
  }
#endif

#endif /* UART_H_ */
